# Tasty Lab Hints



## Hint 3

Student Asks: _I'm struggling to see where we take the user input for the task name._

If we have `command = input('Tasty> ')`

So the `command` variable will have `exit` or whatever, after the user types something in
and taps <return>, right?

And the `new <task>` command/line when entered, will actually look like `new Buy Milk` when user types the
command to be processed by the program.

so take the string inputted and split it into a list of strings, breaking each string on the <space> character.

```python
txt = "command typed by user"

x = txt.split()

print(x)

# x will be a  list: ['command', 'typed', 'by', 'user']
```

If we want to extend this to make two new strings: 
- command (the first string, perhaps "new") 
- and rest (the rest of the split strings glued back together with spaces in between...)

```python
txt = "new Buy Milk"
t = txt.split()
print(t) # t will be: ["new", "Buy", "Milk"]
command = t[0] # command will be "new"
rest = t[1:] # carefully: Slice the array, from t[1] to end of list
             # rest will be ["Buy", "Milk"]
rest = " ".join(rest) # now rest will be "Buy Milk"
print(command, ' - ', rest)
```

and after hacking a bit in the python interpreter, you may end up with

```python
  line = input(prompt)
  #print(line)
  while not line:
    line = input(prompt) # this causes input to wait until 
                         # line is not an empty string
  words = line.split()
  #print(words)
  command = words[0]
  #print(command)
  rest = words[1:]
  rest = " ".join(rest)
  #print(rest)
```

and maybe the right thing to do is to change the `command = input("Tasty> ")` to something like 
`command, rest = tasty.prompt_user("Tasty> ")`

then all the "words" after the "new" will be what you pull together to name the task?

so `prompt-user(self, prompt)` becomes a method which asks for the user's input
(using input(prompt))

```python
def prompt_user(self, prompt):
  inp = input(prompt)
  # insert the stuff up there about how to 
  # split words into a list and process into two parts.
```

### Saving/Loading to a JSON file

JSON is just a structured text format for data. Very Handy.

## saving? a Hint

```python
with open("saved_data.json", "w") as fp:
  json.dump(self.tasks,fp)
```

## loading? a Hint

```python
with open(filename) as json_file:
  self.tasks = json.load(json_file)
```

And you should embed these two ideas into a method.

When you get to the point where you are puzzling over how to save/load multiple dicts 
(say, _tasks_, _trash_, and _important_),
you might consider putting all this in another dictionary and just saving that.

You still have to _load_ the one dict and then split it into three for use by the methods.
This should be done in _load tasks_ method.

The data structure might be created by

```python
dict_to_save = { "tasks": self.tasks, "trash": self.trash, "impt": self.important }
```

You can now _json.dump_ the `dict_to_save` to a file.

Loading it will be the opposite, you end up with one `loaded_dicts` which 
have to be split like: `self.tasks = loaded_dicts['tasks']`


Easy Peasy